'
' -------------------------------------------------------------------
' FbToRqInc     Functions.Inc       June 28th, 2006         by Jacques
' -------------------------------------------------------------------
'
Sub Wait (duration As Single)
    DefSng sngStart
    sngStart = Timer
    Do
        DoEvents
    Loop Until Abs(Timer - sngStart) > duration
End Sub
'
Sub ShellRedirCallBack (Text As String)     ' UnUsed necessary for shellredir
End Sub
'
Sub SaveWinTextAs (sFile As String)
    If MessageDlg("ACTUAL   WINDOW   TEXT   HAS  CHANGED\n\n   ????  SAVE  IT  AS  ????\n\n" & sSelFile , mtWarning, mbOK OR mbCancel, 0) = IdOk Then
        Kill sSelPathFile
        While FileExists (sSelPathFile) = True
            DoEvents
        Wend
        rchWin.SaveToFile (sSelPathFile)
        While FileExists (sSelPathFile) = False
            DoEvents
        Wend
    End If
End Sub

Sub BackUpFile (sFile As String)
    DefStr sExt, sName, sSaved
    DefInt iPtr, N
    If FileExists (sFile) = False Then Exit Sub
    iPtr = RInstr(sFile, "\\")
    If iPtr <> 0 Then
        sFile = Mid$(sFile, iPtr + 1)
    End IF
    iptr = RInstr (sFile, ".")
    If iptr <> 0 Then
        sExt = Mid$(sFile, iPtr)
        sName = Left$(sFile, iPtr - 1) & "_"
    Else
        sExt = ""
        sName = sFile & "_"
    End If
    '
    N = 1000
    MkDir "BackUpToDelete"
    sSaved = "BackUpToDelete\\" & sName & Str$(N) & sExt
    While FileExists (sSaved) = 1
        Inc N
        sSaved = "BackUpToDelete\\" & sName & Str$(N) & sExt
    Wend
    CopyFile (sFile, sSaved, 0)
End Sub
'
Sub DeletePreviousFiles
    DefStr sSaved
    Kill "Temp.Asm"
    Kill "Temp.Nasm"
    Kill "Temp.Inc"
    Kill "Temp.Exe"
    '
    BackUpFile ("Temp.Bas")
    '
    While FileExists("Temp.Asm") = 1
        DoEvents
    Wend
    While FileExists("Temp.Nasm") = 1
        DoEvents
    Wend
    While FileExists("Temp.Inc") = 1
        DoEvents
    Wend
    While FileExists("Temp.Exe") = 1
        DoEvents
    Wend
End Sub

Function FbCompileToAsm () As String
    DefStr sBas, sShell, sFbOutput, sTmp
    DefInt iRet, N = 0, iErrAsExe
    DeletePreviousFiles
  With rchWin
    ' Auto Add 'Option Explicit'
    While Left$(.Line(N), 1) = "'"
        Inc N
        If N >= .LineCount Then
            N = 0
            Exit While
        End IF
    Wend
'
    If Instr(LCase$(.Line(N)), "option explicit") = 0 Then
        .Line(N) =  "Option Explicit\r\n" & .Line(N)
    End If
'
    sBas = .Text
    .SaveToFile ("Temp.Bas")
    While FileExists("Temp.Bas") = 0
        DoEvents
    Wend
    sShell = "FBC -r Temp.Bas"
    sFbOutPut = ShellRedir (sShell)
    ' Error as.exe not found ... occures when trying to compile to exe, we have the .asm
    ' this FB error means all OK on .Asm side.
    iErrAsExe = Instr(sFBOutput,"bin\\win32\\as.exe")
    If iErrAsExe > 0 Then
        sFBOutput = "  ***  FB COMPILED TO .ASM OK  ***   (no exe created)"
        Result = ""
    Else
        Result = sFBOutput
    End If
'
    While FileExists("Temp.Asm") = 0
        DoEvents
    Wend
'
    .LoadFromFile ("Temp.Asm")
'
    sTmp = "___COMPILED FREEBASIC ASM FILE: Temp.Asm___"
    sAll = sAll & "\n\n\n\n" & sTmp & "\n" & String$(Len(sTmp), "*") & "\n" _
                                                              & .Text & "\n" & sFbOutput
    .AddString sFBOutPut
    DoEvents
  End With
End Function
'
Function ExtractNextAsmFunction () As String
    DefStr sLine, sAsmFunc = "", sOut, sTmp
  With rchWin
    ' Search .globl
    While Left$(LCase$(.Line(iScanAsmLine)), 7) <>  ".globl "
        Inc iScanAsmLine
        If iScanAsmLine >= .LineCount Then
            Result = ""
            Exit Function
        End If
    Wend
    sFuncName = Mid$(Field$(.Line(iScanAsmLine), " ", 2), 2)
    iArgNumber = Val(Field$(sFuncName, "@", 2))/4
    sFuncName = Val(Field$(sFuncName, "@", 1))/4
    If LCase$(sFuncName) = "main" Then
        Result = ""
        Exit Function
    End If
    If iArgNumber <> 4 Then
        If MessageDlg     ("RAPIDQ WARNING ONLY :)" _
                     & "\n\nFUNCTION  \"" & sFuncName & "\"  HAS " & Str$(iArgNumber) & "  ARGUMENTS" _
                     & "\n\n  MORE OR LESS THAN 4 ARGUMENTS WILL BUG UNDER XP IF" _
                     & "\n\n  CALLWINDOWPROC IS USED TO CALL THE FUNCTION (RAPIDQ CASE)" _
                     & "\n\n  JUST ADD THE NECESSARY DUMMY ARGUMENTS TO YOUR FUNCTION" _
                     & "\n\n        ???   DO YOU WANT TO CONTINUE   ???", _
                                                       mtWarning, mbYes OR mbNo, 0) = IdNo Then
            Result = "FUNCTION  \"" & sFuncName & "\"  HAS  " & Str$(iArgNumber) & "  ARGUMENTS: 4 REQUIRED"
            Exit Function
        End If
    End If
    IscanAsmLine = IScanAsmLine + 2           ' skip 2 first lines
    ' Grab Asm Lines Until .balign is found
    While Left$(LCase$(.Line(iScanAsmLine)), 8) <>  ".balign "
        sAsmFunc = sAsmFunc & .Line(iScanAsmLine) & "\r\n"
        Inc iScanAsmLine
        If iScanAsmLine >= .LineCount Then
            Result = ""
            Exit Function
        End If
    Wend
    Inc iScanAsmLine
    Result = sAsmFunc
    sOut = "EXTRACTED ASM: " & sFuncName _
    & "\n\n; ----------------------------------------" _
      & "\n; Function Name: " & sFuncName _
      & "\n; Arg Number: "  & Str$(iArgNumber) _
      & "\n; ----------------------------" _
      & "\n" & sAsmFunc _
      &   "; ----------------------------------------"
'
    sTmp = "___EXTRACTED FREEBASIC ASM FUNCTION: " & sFuncName & " ___"
    sAll = sAll & "\n\n\n\n" & sTmp & "\n" & String$(Len(sTmp), "*") & "\n" & sOut
'
    If mnuVerbosely.Checked = 1 Then ShowMessage sOut
  End with
End Function
'
Function TranslateASMtoNASM (sAsm as string) As String
    Dim fileNasm As QFileStream
    DefStr sWord, sNasm = "", sFile, sTmp, sSavedText, sBin, sBinNasm
    DefInt iLine, iRet, iPtr0, iPtr
    Dim lstAsm As QStringList
    If Instr (sAsm, " st(") <> 0 Then  ' Different syntaxe for FPU registers
        sAsm = ReplaceSubStr$(sAsm, "st(0)", "st0")
        sAsm = ReplaceSubStr$(sAsm, "st(1)", "st1")
        sAsm = ReplaceSubStr$(sAsm, "st(2)", "st2")
        sAsm = ReplaceSubStr$(sAsm, "st(3)", "st3")
        sAsm = ReplaceSubStr$(sAsm, "st(4)", "st4")
        sAsm = ReplaceSubStr$(sAsm, "st(5)", "st5")
        sAsm = ReplaceSubStr$(sAsm, "st(6)", "st6")
        sAsm = ReplaceSubStr$(sAsm, "st(7)", "st7")
    End If
    If Instr (sAsm, "ficom") Then sAsm = ReplaceSubStr$(sAsm, "ficom", "fcomi")
    '
    ' ASM   0b110111   >>>   NASM  110111b
    iPtr0 = Instr (sAsm, ", 0b")
    While iPtr0 <> 0
        iPtr = Instr (iPtr0, sAsm, Chr$(13))
        sBin = Mid$(sAsm, iPtr0 + 4, iPtr - (iPtr0 + 4))
        sBinNasm = ", " & sBin & "b "
        sAsm = Replace$(sAsm, sBinNasm, iPtr0)
        iPtr0 = Instr (iPtr0 + 4, sAsm, ", 0b")
    Wend
    '
    lstAsm.Text = sAsm
  With lstAsm
    For iLine = 0 To .ItemCount - 1
        If UCase$(Left$(.Item(iLine), 1)) = "J" Then
            sWord = Left$(.Item(iLine), Instr(.Item(iLine), " "))
            If Instr ("JA JAE JB JBE JC JCXZ JE JG JGE JL JLE JNA JNE JNB JNBE JNC JNE JNG JNGE JNL JNLE JNO JNP JNS JNZ JO JP JPE  JPO JS JZ ", Ucase$(sWord)) <> 0 Then
                .Item(iLine) = ReplaceSubstr$(.Item(iLine), sWord, sWord & "near ")
            End If
        ElseIf Rtrim$(Field$(.Item(iLine), " ", 2)) = "" Then
            sTmp = Left$(.Item(iLine), 4) & " "
            If Instr ("fmul fdiv fadd fsub fcom fxch fuco ", sTmp) > 0 Then .Item(iLine) = Field$(.Item(iLine), " ", 1) & " st1"
        End If
        sNasm = sNasm & "\n" & .Item(iLine)
    Next iLine
    sNasm = ReplaceSubStr$ (sNasm, " ptr", "")
    sTmp =  "; ---- Start Nasm Function : " & sFuncName & " ----"
    sNasm = sTmp & String$(60 - Len(sTmp), "-") _
        & "\n; " & Date$  & " by FBtoRQINC extracted from:  " & sSelFile _
        & "\n; Argument Number: " & Str$(iArgNumber) _
        & "\n; Compile me : Nasmw.exe " & sFuncName & ".Nasm -fbin -o " & sFuncName & ".Bin" _
        & "\n; " & String$(58, "-") _
        & "\n    bits 32" _
        & "\n    segment .text" _
        & "\n    " & sFuncName _
        & "\n; -------------" _
        & sNasm        
    sTmp = "; ---- End Nasm Function " & sFuncName & " ----"
    sNasm = sNasm & "\n" & sTmp & String$(60 - Len(sTmp), "-")
    If mnuLF_Only.Checked = 0 Then sNasm = ReplaceSubStr$(sNasm, Chr$(10), Chr$(13) & Chr$(10))
  End With
    sFile = sFuncName & ".Nasm"
    While FileExists (sFile) = 1
        Kill sFile
        DoEvents
    Wend
    ' Wait for Nasm Code optimize/modify
    If mnuStopOptimizeNasm.Checked = 1 Then
        sSavedText = rchWin.Text
        rchWin.Text = sNasm
        iRet = MessageBox2 (0, "MODIFY/OPTIMZE  NASM  DSPLAYED CODE\n\nTHEN CLIC ME TO CONTINUE" _
                                                 , "FbToRqInc WAIT MODIFY/OPTIMIZE NASM CODE", MBOK Or &H1000)
        sNasm = rchWin.Text
        rchWin.Text = sSavedText
    End If
    '
    fileNasm.Open (sFile, fmCreate)
        fileNasm.WriteBinStr (sNasm, Len(sNasm))
    fileNasm.Close
    While FileExists (sFile) = 0
        DoEvents
    Wend
    '
    sTmp = "___FREEBASIC ASM TRANSLATED TO NASM: " & sFuncName & ".NASM___"
    sAll = sAll & "\n\n\n\n" & sTmp & "\n" & String$(Len(sTmp), "*") & "\n" & sNasm
    '
    If mnuVerbosely.Checked = 1 Then ShowMessage ("NASM:  " & sFile & "\n\n" & sNasm)
End function
'
Function NasmToBin () As String
    DefStr sShell, sTmp
    DefInt iRet, iWso, iOPenCount
    Dim fileDump As QFileStream
    sShell = "Nasmw.exe " & sFuncName & ".Nasm -fbin -EASM.$$$ -o " & sFuncName & ".Bin" & " -l " & sFuncName & ".Lst"
    iRet = Shell (sShell, 0)
    ' Check if Compile OK ....
    If iRet = 0 Then
        Result = "ERROR NASMW COMPILE TO BIN FAILED\n\nNOTHING DONE RETRY"
        Exit Function
    End If
    iWso = WaitForSingleObject (iRet, 5000)
    If iWso = 0 Then
        ' Open Dump File
        iOpenCount = 0
        While fileDump.Open ( "ASM.$$$", fmOpenRead) = 0
            iOpenCount ++
            Wait (0.1)
            If (iOpenCount > 40) Then
                Result = "ERROR: CANNOT OPEN  ASM.$$$  AFTER 4 SECONDS\n\nI STOP, RETRY"
                Exit Function
            End If
        Wend
        If fileDump.Size = 0 Then
            Result = ""
        Else
            sTmp = "ERROR WHILE COMPILING  \"" & sFuncName & "\"  TO BIN"
            sTmp = sTmp +   "\n\n    ---- START NASMW COMPILATION TO BIN ERROR(S)"
            fileDump.Position = 0
            While fileDump.Eof = 0
                sTmp = sTmp & "\n       " & fileDump.ReadLine
            Wend
            sTmp = sTmp +     "\n    ---- END NASM COMPILATION TO BIN ERRORS\n"
            Result = sTmp
        End If
        fileDump.Close
    Else
        Result = "WAITFORSINGLEOBJECT TIMOUT WHILE COMPILING  "& sFuncName & ".Asm  to  BIN\n\nI STOP, RETRY"
    End If
End Function
'
Sub BintoRQInc
    DefStr sInc, sTmp = "", binStringed, ArrayName, sFile
    DefInt N, P, iCountArray, I, iBeg, iEnd, binStringedSize,
    DefInt MaxByteInArray = 650, SplitSize = SPLIT_INC_SIZE
    If SplitSize > 500 Then SplitSize = 500
    Dim fileBin as QFileStream
    Dim fileInc as QFileStream
    sInc = "' " & String$(78, "=")
    sInc = sInc & "\nDECLARE FUNCTION " & sFuncName _
                & " LIB \"user32\" ALIAS \"CallWindowProcA\" ( _\n          ptr" _
                & sFuncName & " As Long"
    For N = 1 To iArgNumber
        sInc = sInc & ", Arg" & Str$(N) & " As Long"
        If N Mod 4 = 0 Then sInc = sInc & " _\n          "
    Next N
    sInc = sInc & ") As Long"
    ' Load Assembly Code In a String
    ArrayName = "Array" & sFuncName
    fileBin.Open (sFuncName & ".Bin", fmOpenRead)
         binStringedSize = fileBin.Size
         binStringed = fileBin.ReadBinStr(binStringedSize)
    fileBin.Close
    If mnuUseNasmBin.Checked = True Then
        sInc = sInc & "\n$RESOURCE LIB_" & sFuncName & " As \"" & sFuncName & ".Bin\"" _
                    & "\nDim MS_" & sFuncName & " As QMemoryStream" _
                    & "\nMS_" & sFuncName & ".ExtractRes(Resource(0))  ' Adapt manually (0) if necessary" _
                    & "\nDefInt ptr" & sFuncName & " = MS_" & sFuncName & ".Pointer"
    Else
        If  binStringedSize <= MaxByteInArray Then      ' Array Method  (<=722)
            sTmp = "\n' ----- START ASM " & sFuncName & " -----\nDefByte " & arrayName _
                                & " (0 To " & Str$(binStringedSize - 1) & ") = _\n   {"
            sInc = sInc + sTmp
            P = 0
            For N = 1 To binStringedSize
                If P = MAX_HEX_PER_LINE Then
                    P = 0
                    sInc = sInc + " _\n    "
                End If
                sInc = sInc + "&H" & Right$ (Hex$ (Asc (binStringed[N]) ), 2)
                If N <> binStringedSize Then
                    sInc = sInc + ", "
                    Inc P
                End If
            Next N
            sInc = sInc + "}\n' ----- END ASM " & sFuncName & " -----"
            ' Pointer
            sInc = sInc + "\nDefInt ptr" & sFuncName & " = VarPtr (" & ArrayName & "(0))"
        Else
            sInc = sInc & "\n' ----- START ASM " & sFuncName
            iCountArray = Int (binStringedSize/SplitSize)
            For I = 0 To iCountArray
                iBeg = SplitSize * I + 1
                iEnd = SplitSize * (I + 1)
                If iEnd > binStringedSize Then iEnd = binStringedSize
                sInc = sInc & "\nDefByte " & arrayName & "_" & Str$(I) _
                            & " (0 To " & Str$(SplitSize - 1) & ") = _\n   {"
                P = 0
                For N = iBeg To iEnd
                    If P = MAX_HEX_PER_LINE Then
                        P = 0
                        sInc = sInc + " _\n    "
                    End If
                    sInc = sInc + "&H" & Right$ (Hex$ (Asc (binStringed[N]) ), 2)
                    If N <> iEnd Then
                        sInc = sInc + ", "
                        Inc P
                    End If
                Next N
                sInc = sInc + "}"
            Next I
            sInc = sInc & "\nDefByte " & arrayName & "(0 To " & Str$((iCountArray + 1) * SplitSize - 1) & ")"
            sInc = sInc & "\nDefInt P_XZYZA"
            sInc = sInc & "\nFor P_XZYZA = 0 To "  & Str$(SplitSize - 1)
            For I = 0 To iCountArray
                sInc = sInc & "\n    " & arrayName & "(P_XZYZA + (" & Str$(I)  & " * " & Str$(SplitSize) _
                                            & ")) = " & arrayName & "_" & Str$(I) & "(P_XZYZA)"
            Next I
            sInc = sInc & "\nNext P_XZYZA"
            sInc = sInc + "\nDefInt ptr" & sFuncName & " = VarPtr (" & ArrayName & "(0))"
            sInc = sInc & "\n' ----- END ASM " & sFuncName & " -----"
        End If
    End If
'
    sInc = sInc & "\n' CALL ME WITH: iRet = " & sFuncName & "(ptr" & sFuncName
    If iArgNumber > 0 Then
        sInc = sInc & ", "
        For N = 1 To iArgNumber
            sInc = sInc & "Arg" & Str$(N)
            If N <> iArgNumber Then
                sInc = sInc & ", "
            End If
        Next N
    End If
    sInc = sInc & ")"
'
    If mnuUseNasmBin.Checked = True Then
        sInc = sInc & "\n' You must copy the file  \"" & sFuncName & ".Bin\"  in your code Directory"
    End If
'
    sInc = sInc & "\n' " & String$(78, "=")
    If mnuLF_Only.Checked = 0 Then sInc = ReplaceSubStr$(sInc, Chr$(10), Chr$(13) & Chr$(10))
    sFile = sFuncName & ".Inc"
    fileInc.Open (sFile, fmCreate)
        fileInc.WriteBinStr (sInc, Len(sInc))
    fileInc.Close
'
    sAllInc = sAllInc & sInc & "\n\n"
'
    sTmp = "___RAPIDQ INC FILE: " & sFuncName & ".INC___"
    sAll = sAll & "\n\n\n\n" & sTmp & "\n" & String$(Len(sTmp), "*") & "\n" & sInc
'
    If mnuVerbosely.Checked = 1 Then ShowMessage ("INC: " & sFuncName & "\n\n" & sInc)
End Sub
'
