'
' ----------------------------------------------------------------------
' CALLING API FROM FB               June 10th, 2006          by  Jacques
' ----------------------------------------------------------------------
' NOTES:
' RapidQ Libs and Dll contain some 500 resolved API. The function pointer
' to these API are stored at a stable addresses. The addresses vary in
' each Lib/Dll.
' RapidQ32.Dll and RapidQCC.Dll are used to execute bytecode,
' RapidQ32.Lib and RapidQCC.Lib are used to build RapidQ executables.
' Other .Lib are subsets of these two .Libs . API pointers'addresse are
' the same for RapidQ32.Lib and RapidQCC.Lib and the same for RapidQ32.Dll
' and RapidQCC.Dll.
'
' So to force the use of RapidQ32.Lib or RapidQCC.Lib you must add to
' your RapidQ Codes the following line:  
'
'    Dim dxtmrABCDE As QDXTimer
'
' Just include  "Api_Resolved_In_Dll.Inc" or "Api_Resolved_In_Lib.Inc"
' in your FB code or paste the required Constantes.
' 
' ----------------------------------------------------------------------
' COMPILE ME WITH FbToRqInc Menu Compile/FB to RQ Inc ...
' ----------------------------------------------------------------------
Option Explicit
' ----------------------------------------------------------------------
Const cGetTickCount As Integer    = &H0052E364  ' Resolved in RapidQCC.Lib
'
Function fbReadGetTickCount (a,b,c,d) As Integer
    Dim GetTickCount as function( ) as integer 
    asm
        mov eax, [cGetTickCount]
        mov dword [GetTickCount], eax
    end asm
    Function = GetTickCount()
End Function
' ----------------------------------------------------------------------
Const cSetConsoleTitle As Integer = &H0052E2E8  ' see File RapidQCC.Inc
' 
Function fbSetConsoleTitle (ByVal ptrTitle As Integer,b,c,d) As Integer
    Dim SetConsoleTitle As Function(ByVal ptrTitle As Integer) As Integer
    asm
        mov eax, [cSetConsoleTitle]
        mov dword [SetConsoleTitle], eax
    end asm
    Function = SetConsoleTitle(ptrTitle)
End Function
' -----------------------------------------------------------------------
' There may be a better solutions ??? I am not an FB expert !
' -----------------------------------------------------------------------
''
'' Three things work:      (thanks to FreeBasic Beginner Forum) 
'' -----------------
''
'' 1 - The inline assembler solution: 
''     -----------------------------
'Const cApiName = &H0033E3FC
''
'Function CallApiName () As Long
'    Dim ApiName as function() as integer
'    asm
'        mov eax, [cApiName]
'        mov dword [ApiName], eax
'    end asm
'    Function = ApiName()
'End Function  	
''
'' 2 - The type solution: 
''     -----------------
'Const cApiName As Integer = &H0052E364
'Type ApiNamePtr As Function() As Integer
'Type ApiNamePtrPtr As ApiNamePtr Ptr
''
'Function CallApiName () As Integer
'    Dim ApiName As Function() As Integer = *cptr(ApiNamePtrPtr, cApiName)
'    Function = ApiName()
'End Function  	
''
'' 3 - The double cPtr solution:
''     ------------------------
'' Const cApiName As Integer = &H0052E364
'Function CallApiName () As Integer
'    Dim ApiName As Function() As Integer = cPtr(Function() As Integer, *cPtr(Integer ptr, cApiName))
'    Function = ApiName()
'End Function
'' ---- ???? More ???? ----------------------------------------------------
''
