'
' -------------------------------------------------------------------
' FbToRqInc        Menu.Inc      June 28th, 2006            by Jacques
' -------------------------------------------------------------------
'
Sub OnClic_AnyMenu (Sender)
  With rchWin
    DefStr sAsm = "", sTmp = "", sInc = "", sTmp2, sOldDir, sShell, sRQOut, sFbOut, sFile
    DefInt N, P, iBeg, iEnd, iLine, iTmp, iRet, iPtr
    Dim fileTmp As QFileStream
    Dim SaveDialog AS QSaveDialog
    Dim fntTmp As QFont
    Dim dlgFont As QFontDialog
    Dim slTmp As QStringList
    Dim tColor As FBA_TCHOOSECOLOR
    DefInt rgbInit (0 To 15) = {&H0, &H808080, &H000080, &H008080, &H008000, &H808000, &H800000, _
           &H800080, &HFFFFFF, &HC0C0C0, &H0000FF, &H00FFFF, &H00FF00, &HFFFF00, &HFF0000, &HFF00FF}
    If flagMenuBusy = True Then Exit Sub
    flagMenuBusy = true
    Select Case Sender.Handle
' FB BAS to FB ASM
        Case mnuFBBAStoFBASM.Handle
            BackUpFile (sSelFile)
            sAll = ""
            sAllInc = ""
            sTmp = "___LOADED FREEBASIC BAS FILE: " & sSelFile & "___"
            sAll = sTmp & "\n" & String$(Len(sTmp), "*") & "\n" & .Text
            '
            sTmp = FbCompileToAsm
            If sTmp <> "" Then
                sAll = sAll & "\n\nFBC ERROR/WARNING:\n" & sTmp
                ShowMessage (sTmp & "\n\n??? ERROR WHILE COMPILING FB BAS TO FB ASM\n\n! I AM FINISHED !")
                flagMenuBusy = False
                Exit Sub
            End If
            rchWin.Modified = False
' FB to INC
        Case mnuFBBAStoRQINC.Handle
            BackUpFile (sSelFile)
            If (sSelFile <> "" and rchWin.Modified = True) Then SaveWinTextAs (sSelPathFile)
            sAll = ""
            sAllInc = ""
            sTmp = "___LOADED FREEBASIC BAS FILE: " & sSelFile & "___"
            sAll = sTmp & "\n" & String$(Len(sTmp), "*") & "\n" & .Text
            '
            sTmp = FbCompileToAsm
            If sTmp <> "" Then
                sAll = sAll & "\n\nFBC ERROR/WARNING:\n" & sTmp
                If MessageBox2 (0, sTmp & "\n\n??? DO YOU WANT TO CONTINUE ???" _
                                                 , "FbToRqInc WAIT ERROR COMPILE FB ASM", mbyes Or &H1000) = IDCANCEL Then   ' MB_SYSTEMMODAL = 1000h
                    flagMenuBusy = False
                    Exit Sub
                End If
            End If
            '
            iSCanAsmLine = 0
            sAsm =  ExtractNextAsmFunction
            While sASm <> ""
                TranslateASMtoNASM (sAsm)
                sTmp = NasmToBin
                If sTmp <> "" Then
                    ShowMessage (sTmp)
                    sAll = sAll & "\n\nEXIT ON NASMW ERROR:\n" & sTmp
                    flagMenuBusy = False
                    Exit Sub
                End If
                BintoRqInc
                sAsm = ExtractNextAsmFunction
            Wend
            .Text = sAllInc
            fileTmp.Open ("All.Out", fmCreate)
                fileTmp.WriteBinStr (sAll, Len(sAll))
            fileTmp.Close
            fileTmp.Open ("AllInc.Out", fmCreate)
                fileTmp.WriteBinStr (sAllInc, Len(sAllInc))
            fileTmp.Close
            rchWin.Modified = False
' SELECTION > ASM
        Case mnuSelAsm.Handle
            BackUpFile (sSelFile)
            DeletePreviousFiles
            sAll = ""
            sAllInc = ""
            sTmp = "___LOADED FREEBASIC ASM FILE: " & sSelFile & "___"
            sAll = sAll & sTmp & "\n\n\n" & String$(Len(sTmp), "*") & "\n" & .Text
'
            iBeg = FBASM_SendMessageX (.Handle, EM_EXLINEFROMCHAR, 0, .SelStart)
            iEnd = FBASM_SendMessageX (.Handle, EM_EXLINEFROMCHAR, 0, .SelStart + .SelLength - 1)
            For iLine = iBeg To iEnd
                sAsm = sAsm & .Line(iLine) & "\n"
            Next iLine
            For iLine = 1 To 5
                iTmp = iBeg - iLine
                If iTmp > 0 Then           '  .globl _MIXSORT@24
                    If Ucase$(Left$(.Line(iTmp), 7)) = ".GLOBL " Then
                        sFuncName = Field$(.Line(iTmp), " ", 2)
                        iArgNumber = Val(Field$(sFuncName, "@", 2))/4
                        sFuncName = Mid$(Field$(sFuncName, "@", 1), 2) ' reject the underscore '_' header
                        iLine = 5 ' = Exit For
                    End If
                Else
                    ShowMessage ("CANNOT FIND FUNCTION NAME\n\n IN THE 5 PREVIOUS LINES\n\nBEFORE SELECTION\n\nNOTHING DONE")
                    flagMenuBusy = False
                    Exit Sub
                End If
            Next N
            sAsm = ReplaceSubStr$(sAsm, Chr$(10), Chr$(13) & Chr$(10))
            If Instr (sAsm, ".globl ") <> 0 Then
                ShowMessage ("YOU PROBABLY SELECT MORE THAN ONE FUNCTION\n\n\".globl \"  WAS FOUND IN THE SELECTION\n\nNOTHING DONE, RETRY" )
                flagMenuBusy = False
                Exit Sub
            End If
'
            sTmp2 =    ("EXTRACTED ASM: " & sFuncName _
                 &  "\n\n; ----------------------------------------" _
                    & "\n; Function Name: " & sFuncName _
                    & "\n; Arg Number: "  & Str$(iArgNumber) _
                    & "\n; ----------------------------" _
                    & "\n" & sAsm _
                    &   "; ----------------------------------------")
            If mnuVerbosely.Checked = 1 Then ShowMessage sTmp2
'
            sTmp = "___SELECTED FREEBASIC ASM FUNCTION: " & sFuncName & " ___"
            sAll = sAll & "\n\n\n\n" & sTmp & "\n" & String$(Len(sTmp), "*") & "\n" & sTmp2
'
            TranslateASMtoNASM (sAsm)
            sTmp = NasmToBin
            If sTmp <> "" Then
                ShowMessage (sTmp)
                flagMenuBusy = False
                Exit Sub
            End If
            BintoRqInc
            .Text = sAllInc
            fileTmp.Open ("All.Out", fmCreate)
                fileTmp.WriteBinStr (sAll, Len(sAll))
            fileTmp.Close
            fileTmp.Open ("AllInc.Out", fmCreate)
                fileTmp.WriteBinStr (sAllInc, Len(sAllInc))
            fileTmp.Close
            ShowMessage ("THE CONTENT OF THIS RICHTEXT WINDOW WAS\n\nSAVED AS \"" _
                           & sFuncName & ".Inc\"\n\nFINISHED, READY FOR A NEW TRANSLATION")
'
            rchWin.Modified = False
        Case mnuNasmToRqInc.Handle
            BackUpFile (sSelFile)
            If (sSelFile <> "" and rchWin.Modified = True) Then SaveWinTextAs (sSelPathFile)
            sAll = ""
            sAllInc = ""
            sFuncName = sSelFileNoExt
            '
            iArgNumber = 0
            For N = rchWin.LineCount - 1 To 0 Step -1
                If Left$(LTrim$(LCase$(rchWin.Line(N))), 4) = "ret " Then
                    iPtr = Instr (LCase$(rchWin.Line(N)), "ret ")
                    If iPtr <> 0 then
                        sTmp = rchWin.Line(N)
                        P = Instr (sTmp, ";")
                        If P <> 0 Then
                            sTmp = Left$(sTmp, P - 1)
                        End If
                        While Instr(sTmp, "  ") <> 0
                            sTmp = ReplaceSubStr$(sTmp, "  ", " ")
                        Wend
                        sTmp = Field$(LTrim$(sTmp), " ", 2)
                        iArgNumber = (Val(sTmp))/4
                    End If
                    Exit For
                End If
            Next N
            If iArgNumber <> 4 Then
                If MessageDlg ("  RAPIDQ WARNING ONLY:)" _
                         & "\n\n  THIS NASM FUNCTION END WITH  \"RET " & Str$(iArgNumber * 4) & "\""_
                         & "\n\n  MORE OR LESS THAN 4 ARGUMENTS WILL BUG UNDER XP IF" _
                         & "\n\n  CALLWINDOWPROC IS USED TO CALL THE FUNCTION (RAPIDQ CASE)." _
                         & "\n\n  JUST REPLACE THAT RET LINE BY  \"ret 16\"" _
                         & "\n\n        ???   DO YOU WANT TO CONTINUE   ???", _
                                                          mtWarning, mbYes OR mbNo, 0) = IdNo Then
                    flagMenuBusy = False
                    Exit Sub
                End If
            End If
            '
            .SaveToFile (sFuncName & ".Nasm")
            While FileExists(sFuncName & ".Nasm") = 0
                DoEvents
            Wend
           '
            sTmp = "___LOADED NASM ASM/NASM FILE: " & sFuncName & ".Nasm___"
            sAll = sTmp & "\n" & String$(Len(sTmp), "*") & "\n" & .Text
            sTmp = NasmToBin
            If sTmp <> "" Then
                ShowMessage (sTmp)
                sAll = sAll & "\n\nEXIT ON NASMW ERROR:\n" & sTmp
                flagMenuBusy = False
                Exit Sub
            End If
            '
            BintoRqInc
            '
            .Text = sAllInc
            fileTmp.Open ("All.Out", fmCreate)
                fileTmp.WriteBinStr (sAll, Len(sAll))
            fileTmp.Close
            fileTmp.Open ("AllInc.Out", fmCreate)
                fileTmp.WriteBinStr (sAllInc, Len(sAllInc))
            fileTmp.Close
'
            rchWin.Modified = False
        Case mnuRQCompileAndExecute.Handle
            BackUpFile (sSelFile)
            If (sSelFile <> "" and rchWin.Modified = True) Then SaveWinTextAs (sSelPathFile)
            If FileExists (RQ_LIB_DIR & "\\RapidQ32.Dll") = 0 Then
                ShowMessage ("IMPOSIBLE TO COMPILE RAPIDQ CODES:" _
                           & "\n\nA FULL RAPIDQ IS NOT INSTALLED OR RQ_??? DIRECTORIES," _
                           & "\n\nCONFIGURATE ON TOP OF \"FbToRqInc.Bas\" -RAPIDQ SOURCE FILE" _
                           & "\n\nOF THIS SOFTWARE-, ARE WRONG. MODIFY THEM AND RECOMPILE." _
                           & "\n\n                  ! NOTHING DONE !" )
                flagMenuBusy = False
                Exit Sub
            End If
            DeletePreviousFiles
            .SaveToFile ("Temp.Bas")
            While FileExists("Temp.Bas") = 0
                DoEvents
            Wend
            sShell = "\"" & RQ_EXEPATHFILE & "\\RC.Exe\" \"-I" & RQ_INC_DIR & "\" \"-L" _
                                                           & RQ_LIB_DIR & "\" \"Temp.Bas\""
            sRQOut = ShellReDir (sShell)
            If Instr(sRqOut, "Compile time: ") = 0 Then
                ShowMessage (sRqOut & "\n\nWILL NOT EXECUTE. RQ COMPILE IS VERY BASIC ???" _
                      & "\n\nI AM FINISHED")
            Else
                While FileExists("Temp.Exe") = 0
                    DoEvents
                Wend
                DoEvents
                iRet = Shell ("Temp.Exe", 5) ' SW_SHOW = 5
            End If
            rchWin.Modified = False
'
        Case mnuFBCompileAndExecute.Handle
            BackUpFile (sSelFile)
            If (sSelFile <> "" and rchWin.Modified = True) Then SaveWinTextAs (sSelPathFile)
            If FileExists (FBC_DIR & "\\bin\\win32\\As.Exe") = 0 Then
                ShowMessage ("IMPOSSIBLE TO COMPILE FREEBASIC CODES:" _
                           & "\n\nA FULL FREEBASIC IS NOT INSTALLED OR FBC_??? DIRECTORIES," _
                           & "\n\nCONFIGURATE ON TOP OF \"FbToRqInc.Bas\" -RAPIDQ SOURCE FILE" _
                           & "\n\nOF THIS SOFTWARE-, ARE WRONG. MODIFY THEM AND RECOMPILE." _
                           & "\n\n                   ! NOTHING DONE !")
               flagMenuBusy = False
                Exit Sub
            End If
            DeletePreviousFiles
            .SaveToFile ("Temp.Bas")
            While FileExists("Temp.Bas") = 0
                DoEvents
            Wend
            sShell = "\"" & FBC_DIR & "\\fbc.exe\" -p \"" & FBC_LIB_DIR _
                                               & "\" -i \"" & FBC_INC_DIR & "\" -v -r \"Temp.Bas\""
            sFBOut = ShellReDir (sShell)
'
            If (Instr (sFBOut, "error") > 0 Or Instr (sFBOut, "cannot find") > 0) Then
                ShowMessage (sFBOut  & "\n\nWILL NOT EXECUTE. RQ COMPILE IS VERY BASIC ???" _
                      & "\n\nI AM FINISHED")
            Else
                While FileExists("Temp.Exe") = 0
                    DoEvents
                Wend
                DoEvents
                iRet = Shell ("Temp.Exe", 5) ' SW_SHOW = 5
            End If
            rchWin.Modified = False
' FILE
        Case mnuNew.Handle, mnuNewDir.Handle
            SaveDialog.Filter = "FREEBASIC FILES|*.Bas;*.Asm|All Files|*.*"
            SaveDialog.FilterIndex = 1
            SaveDialog.InitialDir = sSelPath
            If SaveDialog.Execute Then
                fileTmp.Open (SaveDialog.FileName, fmCreate)
                fileTmp.Close
                ShowMessage (" You must now select\n\n \"" & SaveDialog.FileName & "\"\n\n in the DirBox and FileListBox to avoid\n\n erroneous directory use (will be solved later :)")
            End If
            rchWin.Clear
            rchWin.Modified = False
        Case mnuSaveAs.Handle
            SaveDialog.Filter = "FREEBASIC FILES|*.Bas;*.Asm|All Files|*.*"
            SaveDialog.FilterIndex = 1
            sOldDir = CurDir$
            SaveDialog.InitialDir = sSelPath
            If SaveDialog.Execute Then
                .SaveToFile (SaveDialog.FileName)
            End If
            ChDir sOldDir
' OPTIONS
         case mnuRchWinFont.Handle
            fntTmp.Name =  .font.Name
            fntTmp.Size =  .font.Size
            fntTmp.Color = .font.Color
            dlgFont.GetFont(fntTmp)
            If dlgFont.Execute = 0 Then
               ShowMessage("Error While Setting Main Window Fonts \n\n NOTHING DONE")
            Else
                dlgFont.SetFont(fntTmp)
                rchWin.font = fntTmp
            End If
         Case mnuRchWinBGColor.Handle
            tColor.lStructSize = 36
            tColor.hwndOwner = Application.Handle
            tColor.hInstance = 0
            tColor.rgbResult = rchWin.Color
            tColor.lpCustColors = VarPtr(RgbInit(0))
            tColor.flags = 131        ' CC_FULLOPEN = 2 ; CC_RGBINIT = 1 ; CC_SOLIDCOLOR = 128 ; CC_ANYCOLOR = 256 = &H100
            tColor.lCustData = 0      ' ignored
            tColor.lpfnHook = 0       ' ignored
            tColor.lpTemplateName = 0 ' ignored
            If ChooseColor (tColor) <> 0 Then rchWin.Color = tColor.rgbResult
         case mnuRchDocFont.Handle
            fntTmp.Name =  rchDoc.font.Name
            fntTmp.Size =  rchDoc.font.Size
            fntTmp.Color = rchDoc.font.Color
            dlgFont.GetFont(fntTmp)
            If dlgFont.Execute = 0 Then
               ShowMessage("Error While Setting Doc Window Fonts \n\n NOTHING DONE")
            Else
                dlgFont.SetFont(fntTmp)
                rchDoc.font = fntTmp
            End If
         Case mnuRchDocBGColor.Handle
            tColor.lStructSize = 36
            tColor.hwndOwner = Application.Handle
            tColor.hInstance = 0
            tColor.rgbResult = rchDoc.Color
            tColor.lpCustColors = VarPtr(RgbInit(0))
            tColor.flags = 131        ' CC_FULLOPEN = 2 ; CC_RGBINIT = 1 ; CC_SOLIDCOLOR = 128 ; CC_ANYCOLOR = 256 = &H100
            tColor.lCustData = 0      ' ignored
            tColor.lpfnHook = 0       ' ignored
            tColor.lpTemplateName = 0 ' ignored
            If ChooseColor (tColor) <> 0 Then rchDoc.Color = tColor.rgbResult
         case mnuDirFileFont.Handle
            fntTmp.Name =  lstFiles.font.Name
            fntTmp.Size =  lstFiles.font.Size
            fntTmp.Color = lstFiles.font.Color
            dlgFont.GetFont(fntTmp)
            If dlgFont.Execute = 0 Then
               ShowMessage("Error While Setting Dir File Lists Fonts \n\n NOTHING DONE")
            Else
                dlgFont.SetFont(fntTmp)
                fntTmp.Color = 0           ' no color set allowed Back
                lstFiles.font = fntTmp
                dirTree.Font = fntTmp
                dirTree.Font.Color = &H80  ' dirTree.Font.Color dont work ????
            End If
         Case mnuLF_Only.Handle
            If mnuLF_Only.Checked = 1 Then
                mnuLF_Only.Checked = 0
            Else
                mnuLF_Only.Checked = 1
            End If
         Case mnuVerbosely.Handle
            If mnuVerbosely.Checked = 1 Then
                mnuVerbosely.Checked = 0
            Else
                mnuVerbosely.Checked = 1
            End If
        Case mnuUseNasmBin.Handle
            If mnuUseNasmBin.Checked = 1 Then
                mnuUseNasmBin.Checked = 0
            Else
                mnuUseNasmBin.Checked = 1
            End If
        Case mnuStopOptimizeNasm.Handle
            If mnuStopOptimizeNasm.Checked = 1 Then
                mnuStopOptimizeNasm.Checked = 0
            Else
                mnuStopOptimizeNasm.Checked = 1
            End If
' HELP
        Case mnuNewBie.Handle
            rchDoc.Text = sMinimumDoc
            rchDoc.Visible = True
            SetFocus rchDoc.Handle
        Case mnuPassString.Handle
            rchDoc.OnMouseDown = 0
            sTmp =  "\r\n                ***  PUSH ANY KEY TO GO BACK TO CODE EDITOR  ***\r\n" _
                  & "\r\n               ***  YOU MAY CUT AND PASTE IN THIS HELP WINDOW ***\r\n"
            slTmp.LoadFromFile (sAppDir & "Examples\\PassingString\\FB_String.Bas")
            sTmp = sTmp & slTmp.Text
            slTmp.LoadFromFile (sAppDir & "Examples\\PassingString\\RQ_String.Bas")
            sTmp = sTmp & "\n\n\n\n" & slTmp.Text
            rchDoc.Text = sTmp
            rchDoc.Visible = True
            SetFocus rchDoc.Handle
        Case mnuPassArray.Handle
            rchDoc.OnMouseDown = 0
            sTmp =  "\r\n                ***  PUSH ANY KEY TO GO BACK TO CODE EDITOR  ***\r\n" _
                  & "\r\n               ***  YOU MAY CUT AND PASTE IN THIS HELP WINDOW ***\r\n"
            slTmp.LoadFromFile (sAppDir & "Examples\\PassingArray\\FB_Array.Bas")
            sTmp = sTmp & slTmp.Text
            slTmp.LoadFromFile (sAppDir & "Examples\\PassingArray\\RQ_Array.Bas")
            sTmp = sTmp & "\n\n\n\n" & slTmp.Text
            rchDoc.Text = sTmp
            rchDoc.Visible = True
            SetFocus rchDoc.Handle
        Case mnuPassType.Handle
            rchDoc.OnMouseDown = 0
            sTmp =  "\r\n                ***  PUSH ANY KEY TO GO BACK TO CODE EDITOR  ***\r\n" _
                  & "\r\n               ***  YOU MAY CUT AND PASTE IN THIS HELP WINDOW ***\r\n"
            slTmp.LoadFromFile (sAppDir & "Examples\\PassingType\\FB_Type.Bas")
            sTmp = sTmp & slTmp.Text
            slTmp.LoadFromFile (sAppDir & "Examples\\PassingType\\RQ_Type.Bas")
            sTmp = sTmp & "\n\n\n\n" & slTmp.Text
            rchDoc.Text = sTmp
            rchDoc.Visible = True
            SetFocus rchDoc.Handle
        Case mnuPassDouble.Handle
            rchDoc.OnMouseDown = 0
            sTmp =  "\r\n                ***  PUSH ANY KEY TO GO BACK TO CODE EDITOR  ***\r\n" _
                  & "\r\n               ***  YOU MAY CUT AND PASTE IN THIS HELP WINDOW ***\r\n"
            slTmp.LoadFromFile (sAppDir & "Examples\\PassingDouble\\FB_DoubleMul.Bas")
            sTmp = sTmp & slTmp.Text
            slTmp.LoadFromFile (sAppDir & "Examples\\PassingDouble\\RQ_DoubleMul.Bas")
            sTmp = sTmp & "\n\n\n\n" & slTmp.Text
            slTmp.LoadFromFile (sAppDir & "Examples\\PassingDouble\\FB_DoubleTest.Bas")
            sTmp = sTmp & "\n\n\n\n" & slTmp.Text
            slTmp.LoadFromFile (sAppDir & "Examples\\PassingDouble\\RQ_DoubleTest.Bas")
            sTmp = sTmp & "\n\n\n\n" & slTmp.Text
            rchDoc.Text = sTmp
            rchDoc.Visible = True
            SetFocus rchDoc.Handle
        Case mnuCallApi.Handle
            rchDoc.OnMouseDown = 0
            sTmp =  "\r\n                ***  PUSH ANY KEY TO GO BACK TO CODE EDITOR  ***\r\n" _
                  & "\r\n               ***  YOU MAY CUT AND PASTE IN THIS HELP WINDOW ***\r\n"
            slTmp.LoadFromFile (sAppDir & "Examples\\CallingApi\\FB_Api.Bas")
            sTmp = sTmp & slTmp.Text
            slTmp.LoadFromFile (sAppDir & "Examples\\CallingApi\\RQ_Api.Bas")
            sTmp = sTmp & "\n\n\n\n" & slTmp.Text
            rchDoc.Text = sTmp
            rchDoc.Visible = True
            SetFocus rchDoc.Handle
        Case mnuApiInLib32CC.Handle
            rchDoc.OnMouseDown = 0
            sTmp =  "\r\n                ***  PUSH ANY KEY TO GO BACK TO CODE EDITOR  ***\r\n" _
                   & "\r\n          ***  YOU MAY SEARCH, CUT AND PASTE IN THIS HELP WINDOW  ***\r\n"
            slTmp.LoadFromFile (sAppDir & "Examples\\CallingApi\\RQ_RESOLVED_APIS\\Api_Resolved_In_Lib.Inc")
            sTmp = sTmp & slTmp.Text
            rchDoc.Text = sTmp
            rchDoc.Visible = True
            SetFocus rchDoc.Handle
        Case mnuApiInDll32CC.Handle
            rchDoc.OnMouseDown = 0
            sTmp =  "\r\n                ***  PUSH ANY KEY TO GO BACK TO CODE EDITOR  ***\r\n" _
                   & "\r\n          ***  YOU MAY SEARCH, CUT AND PASTE IN THIS HELP WINDOW  ***\r\n"
            slTmp.LoadFromFile (sAppDir & "Examples\\CallingApi\\RQ_RESOLVED_APIS\\Api_Resolved_In_Dll.Inc")
            sTmp = sTmp & slTmp.Text
            rchDoc.Text = sTmp
            rchDoc.Visible = True
            SetFocus rchDoc.Handle
        Case mnuHelpCompSel.Handle
            rchDoc.Text = sHelpCompileSelection
            rchDoc.Visible = True
            SetFocus rchDoc.Handle
        Case mnuHelpCompFBBAS.Handle
            rchDoc.Text = sHelpCompileFBBAS
            rchDoc.Visible = True
            SetFocus rchDoc.Handle
        Case mnuHelpSelected.Handle
            frmViewDoc.Visible = True
            frmViewDoc.Show
            MinSet(frmViewDoc.handle, -8, 0, application.handle)
            OleIE.createObject ("Shell.Explorer.1")
            DefStr sFileXX = "command reference.html"
            sTmp = .SelText
            DefStr sUrl = sAppDir & "FbDocHtml\\" & sFileXX & "#" & sTmp
            oleIE.Navigate (sUrl)
        Case mnuWiki.Handle
            iRet = ShellExecute (frmFBTORQINC.Handle, "Open", "http://www.freebasic.net/wiki/wikka.php?wakka=FBWiki", "", "", 1)
        Case mnuForum.Handle
            iRet = ShellExecute (frmFBTORQINC.Handle, "Open", "http://www.freebasic.net/forum/", "", "", 1)
        Case mnuFB_Chm.Handle
            sTmp =  sAppDir & "FbDocHtml"
            sFile = ""
            sFile = Dir$(sTmp & "\\FB-Manual*.Chm", 0)
            If sFile = "" Then
                If MessageDlg("NO  \"FB_MANUEL*.Chm\"  FILE  IN  DIRECTORY\n\n" & sTmp _
                         & "\n\n???  DO YOU WANT TO DOWNLOAD IT NOW ???", mtConfirmation, _
                                                                   mbYes OR mbNo, 0) = IdYes Then
                    iRet = ShellExecute (frmFBTORQINC.Handle, "Open", _
                           "http://prdownloads.sourceforge.net/fbc/FB-manual-chm-19.may.2006.zip", "", "", 1)
                End If
                ShowMessage ("NOW YOU SHOULD UNZIP THE DOWNLOADED FILE\n\nFBTORQINC IN THE DIRECTORY:\n\n" & sTmp)
            Else
                sFile = sTmp & "\\" & sFile
                iRet = ShellExecute (frmFBTORQINC.Handle, "Open", sFile, "", "", 1)
            End If
        Case mnuHelpHelp.Handle
            rchDoc.Text = sHelpHelp
            rchDoc.Visible = True
            SetFocus rchDoc.Handle
        Case mnuHelpIDE.Handle
            rchDoc.Text = sHelpIde
            rchDoc.Visible = True
            SetFocus rchDoc.Handle
        Case mnuOutPutType.Handle
            rchDoc.Text = sOutPutType
            rchDoc.Visible = True
            SetFocus rchDoc.Handle
        Case mnuVeryShortAsmDoc.Handle
            rchDoc.Text = sVeryShortAsmDoc
            rchDoc.Visible = True
            SetFocus rchDoc.Handle
    End Select
    OnClic_btnRefresh
    flagMenuBusy = False
  End with
End Sub
'
